from __future__ import print_function
import re

class Codesys_Devices:
  PLCs = 4096
  SoftMotion_PLCs = 4102
  Ethercat_Master = 64
  Ethercat_Slave = 65
  Ethercat_Module = 68  #KL's

def CrateFolder(FolderPath, FolderName):
   found = FolderPath.find(FolderName)
   if not found:
      FolderPath.create_folder(FolderName)
      found = FolderPath.find(FolderName)
   return found[0]

def getname(deviceid):
  allDevDescs = device_repository.get_all_devices()
  for devDesc in allDevDescs:
    if devDesc.device_id.id == deviceid.id and devDesc.device_id.version == deviceid.version:
      return devDesc.device_info.name

def get_modules(treeobj, Nodes):
  name = treeobj.get_name(False)
  if treeobj.is_device:
    n= []
    name = treeobj.get_name(False)
    deviceid = treeobj.get_device_identification()
    print("name: {}, Module: {}, type: {}, Enable: {}".format(name, getname(deviceid), deviceid.type, treeobj.is_enabled()))
    if deviceid.type == 65: #Only slaves, no softmotion sub
      Nodes.append([name, treeobj.is_enabled(), getname(deviceid)])
  # we recursively call the get_modules function for the child objects.
  for child in treeobj.get_children(False):
      get_modules(child, Nodes)
  return(Nodes)

if __name__=="__main__":
  proj = projects.primary
  app = proj.active_application

  for obj in projects.primary.get_children():
    if obj.is_device:
      deviceid = obj.get_device_identification()
      if deviceid.type == Codesys_Devices.PLCs or deviceid.type == Codesys_Devices.SoftMotion_PLCs:
        for child in obj.get_children(False):
          if child.is_device:
            deviceid = child.get_device_identification()
            if deviceid.type == Codesys_Devices.Ethercat_Master:
              Nodes = []
              Modules = get_modules(child, Nodes)

              # Make enum content
              IdSystem = 1001
              STRUCT_CONTENT= ""
              for i in range(len(Modules)):
                if Modules[i][1]:
                #   print("{}:= {}, //{}".format(Modules[i][0], IdSystem, Modules[i][2]))
                  STRUCT_CONTENT += "\t{}:= {}, //{}".format(Modules[i][0], IdSystem, Modules[i][2]) + ",\r\n"
                  IdSystem+= 1
              STRUCT_CONTENT+= "\r\n"

              myfolder = CrateFolder(app, "Ethercat")

              # Find the pou and delete it
              found = myfolder.find("E_Nodes")
              if found:
                found[0].remove()

              mypou = myfolder.create_dut(name = "E_Nodes", type= DutType.EnumerationWithTextList) #EnumerationWithTextList
              mypou.textual_declaration.insert(4, 0, STRUCT_CONTENT)
              mypou.textual_declaration.insert(1, 0, "//")
              break
        break

  print("--- Script finished. ---")
